// @flow
import type {Context} from 'js/generate.js';
import Ast from 'js/ast/ast.js';
import type {JsAst, VarType} from 'js/ast/ast.js';
import M from 'js/ast/macros';

const _pattern = (schema: JsonSchema, symbol: VarType, context: Context): JsAst => {
  const {pattern} = schema;
  if (pattern) {
    const check = Ast.If(
      Ast.Unop.Not(Ast.Call(
        Ast.PropertyAccess(symbol, 'match'),
        Ast.Literal(`/${pattern}/`),
      )),
      context.error(schema, 'pattern'),
    );
    return M.TypeCheck('string', symbol, check);
  } else {
    return Ast.Empty;
  }
};

export default _pattern;
